<template>
  <div v-bind:class="{published: published, unpublished: !published}"
       v-on:click="togglePublish">
    <h3 v-if="body">{{ title }}</h3>
    <h3 v-else v-bind:class="classObject">
      <router-link :to="articleUrl">{{ title }}</router-link>
    </h3>
    <div v-bind:style="{'font-weight': fontWeight, fontSize: '1.2em'}"
         v-on:click.stop="logAuthor">{{ authorName }}</div>
    <div>
      {{ body }}
    </div>
  </div>
</template>

<script>
export default {
  name: 'Article',
  props: {
    id: Number,
    title: String,
    body: String,
    author: String,
    isPublished: Boolean
  },
  data: function() {
    return {
      published: this.isPublished
    }
  },
  computed: {
    articleUrl: function() {
      return '/article/' + this.id;
    },
    authorName: function() {
      return "Author: " + this.author.toUpperCase();
    },
    classObject: function() {
      return {
        published: this.published,
        unpublished: !this.published
      }
    },
    fontWeight: function() {
      return this.published ? 'bold' : 'normal';
    }
  },
  methods: {
    togglePublish: function(event) {
      this.published = !this.published;
      console.log("Tag " + event.target.tagName +
        " clicked, article " + this.title);
    },
    logAuthor: function() {
      console.log(this.author);
    }
  },
  watch: {
    published: function(oldValue, newValue) {
      console.log("Article " + this.title + " published is changed from " +
        oldValue + " to " + newValue);
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h3 {
  color: #999;
}
.published {
  color: darkblue;
}
.unpublished {
  color: red;
}
</style>
